#include "linkedlist.h"
#include <string.h>

LinkedList* createLinkedList()
{
	LinkedList* pReturn = NULL;

	pReturn = (LinkedList*)malloc(sizeof(LinkedList));

	if(pReturn != NULL)
	{
		memset(pReturn, 0, sizeof(LinkedList));
	}
	else
	{
		printf("LinkedList  Ҵ \n");
	}

	return pReturn;
}

int addLLElement(LinkedList* pList, int position, ListNode element)
{
	int i = 0;
	int ret = FALSE;

	ListNode* pNewNode = NULL;
	ListNode* pPreNode = NULL;

	if( pList != NULL )
	{
		if( position >= 0 && position <= pList->curElementCnt )
		{
			pNewNode = (ListNode*)malloc(sizeof(ListNode));

			if( pNewNode != NULL )
			{
				*pNewNode = element;
				pNewNode->pLink = NULL;

				pPreNode = &(pList->headerNode);

				for(i=0; i<position; i++)
				{
					pPreNode = pPreNode->pLink;
				}

				pNewNode->pLink = pPreNode->pLink;
				pPreNode->pLink = pNewNode;

				pList->curElementCnt++;

				ret = TRUE;
			}
			else
			{
				printf("addLLelement Error! pNewNode Ҵ  \n");
			}
		}
		else
		{
			printf("addLLelement Error! 0<=position<=curElementCnt  ƴմϴ. \n");
		}
	}

	return ret;
}

int removeLLElement(LinkedList* pList, int position)
{
	int i = 0;
	int ret = FALSE;

	if( pList != NULL)
	{
		if( position >= 0 && position < pList->curElementCnt )
		{
			ListNode* pDelNode = NULL;
			ListNode* pPreNode = NULL;

			pPreNode = &(pList->headerNode);

			for(i=0; i<position; i++)
			{
				pPreNode = pPreNode->pLink;
			}

			pDelNode = pPreNode->pLink;

			pPreNode->pLink = pDelNode->pLink;

			free(pDelNode);

			pList->curElementCnt--;

			ret = TRUE;
		}
		else
		{
			printf("removeLLElemnet Error! 0<=position<pList->curElementCnt  ƴ \n");
		}
	}

	return ret;
}

ListNode* getLLElement(LinkedList* pList, int position)
{
	int i = 0;

	ListNode* pReturn = NULL;

	if( pList != NULL )
	{
		if( position >= 0 && position < pList->curElementCnt )
		{
			pReturn = &(pList->headerNode);

			for(i=0; i<=position; i++)
			{
				pReturn = pReturn->pLink;
			}
		}
		else
		{
			printf("getLLElement Error! 0<=position<=curElementCnt  ƴ \n");
		}
	}

	return pReturn;
}

void deleteLinkedList(LinkedList* pList)
{
	if( pList != NULL )
	{
		clearLinkedList(pList);

		free(pList);
	}
}



void clearLinkedList(LinkedList* pList)
{
	if( pList != NULL )
	{
		//while( pList->curElementCnt != 0 )
		//while( pList->headerNode.pLink != NULL )
		while(pList->curElementCnt > 0)
		{
			removeLLElement(pList, 0);
		}
	}
}


int getLinkedListLength(LinkedList* pList)
{
	int ret = 0;

	if( pList != NULL )
	{
		ret = pList->curElementCnt;
	}

	return ret;
}

void displayLinkedList(LinkedList* pList)
{
	int i = 0;
	int cnt = getLinkedListLength(pList);
	
	if( pList != NULL )
	{
		printf("   : %d \n", cnt);

		for(i=0; i<cnt; i++)
		{
			printf("[%d] : %d \n", i, getLLElement(pList, i)->data);
		}
	}
	else
	{
		printf("Ұ ϴ. \n");
	}
}